/*
 * Created on 2005. 5. 28.
 */
package net.javajigi.security.web.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.security.service.PasswordMisMatchException;
import net.javajigi.security.service.SecurityService;
import net.javajigi.security.service.UserNotFoundException;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.actions.DispatchAction;

/**
 * @author 缺
 */
public class SecurityAction extends DispatchAction {
    /**
     * Logger for this class
     */
    private static final Logger logger = Logger.getLogger(SecurityAction.class);

    private SecurityService securityService = null;

    public void setSecurityService(SecurityService securityService) {
        this.securityService = securityService;
    }

    public ActionForward login(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response) {
        if (log.isDebugEnabled()) {
            log.debug("Login User...");
        }

        String userId = request.getParameter("userId");
        String password = request.getParameter("password");

        ActionErrors errors = new ActionErrors();
        try {
            securityService.authenticate(userId, password);
        } catch (UserNotFoundException e) {
			logger.error(e);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("user.notfound.error"));
        } catch (PasswordMisMatchException e) {
            logger.error(e);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("password.mismatch.error"));
		}
        
        if( !errors.isEmpty() ) {
            saveErrors(request, errors);
            
            return mapping.getInputForward();
        }

        return mapping.findForward("list");
    }
}