/*
 * Created on 2005. 5. 28.
 */
package net.javajigi.security.web.action;

import org.apache.log4j.Logger;


/**
 * @author 缺
 */
public class SecurityActionTest extends UserActionTest {
    /**
     * Logger for this class
     */
    private static final Logger logger = Logger
            .getLogger(SecurityActionTest.class);

    /*
     * @see MockStrutsTestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
    }

    /*
     * @see MockStrutsTestCase#tearDown()
     */
    protected void tearDown() throws Exception {
        super.tearDown();
    }

    public void testLogin() {
        if( logger.isDebugEnabled() ) {
            logger.debug("Start testLogin method");
        }
        
        String userId = "JavaJiGi";
        String password = "pass";
        
        addUser(userId, password);
        
		setRequestPathInfo("/security");
		addRequestParameter("method", "login");
		addRequestParameter("userId", userId);
		addRequestParameter("password", password);
        
		actionPerform();
        
        verifyForward("list");
        verifyNoActionErrors();		
        
        deleteUser("JavaJiGi");
    }
    
    public void testLoginFailed() {
        if( logger.isDebugEnabled() ) {
            logger.debug("Start testLogin method");
        }
        
        String userId = "JavaJiGi";
        String password = "pass";
        
        addUser(userId, password);
        
		setRequestPathInfo("/security");
		addRequestParameter("method", "login");
		addRequestParameter("userId", "SanJiGi");
		addRequestParameter("password", password);
        
		actionPerform();
        
        verifyForwardPath("/login.jsp");
        verifyActionErrors(new String[]{"user.notfound.error"});		
        
        if( logger.isDebugEnabled() ) {
            logger.debug("End testLogin method");
        }
        
        deleteUser("JavaJiGi");
    }
    
    public void testLoginPasswordMisMatch() {
        if( logger.isDebugEnabled() ) {
            logger.debug("Start testLoginPasswordMisMatch method");
        }
        
        String userId = "JavaJiGi";
        String password = "pass";
        
        addUser(userId, password);
        
		setRequestPathInfo("/security");
		addRequestParameter("method", "login");
		addRequestParameter("userId", "JavaJiGi");
		addRequestParameter("password", "password");
        
		actionPerform();
        
        verifyForwardPath("/login.jsp");
        verifyActionErrors(new String[]{"password.mismatch.error"});		
        
        if( logger.isDebugEnabled() ) {
            logger.debug("End testLoginPasswordMisMatch method");
        }
        
        deleteUser("JavaJiGi");
    }
    
}
