/*
 * Created on 2005. 5. 11.
 */
package net.javajigi.initailize;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;

import net.javajigi.timer.Log4JConfRefreshTimer;
import net.javajigi.util.Configuration;

import org.apache.log4j.Logger;

/**
 * @author Administrator
 */
public class InitializeServlet extends HttpServlet {
	private static String realPath = null;

	/**
	 * Logger for this class
	 */
	private static final Logger logger = Logger
			.getLogger(InitializeServlet.class);

	private Log4JConfRefreshTimer timer = null;

	/**
	 *  
	 */
	public InitializeServlet() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.servlet.GenericServlet#init()
	 */
	public void init() throws ServletException {
		if (logger.isInfoEnabled()) {
			logger.info("Application Initialize Start!!");
		}

		realPath = getServletContext().getRealPath("/");
		if (logger.isDebugEnabled()) {
			logger.debug("Web Application Real Path : " + realPath);
		}

		Configuration.set("ikki.webapp.rootdir", realPath);
		try {
			Configuration.init(realPath + File.separator + "WEB-INF"
					+ File.separator + "ikki.properties");
		} catch (FileNotFoundException e) {
			logger.error("ikki.properties  ʱȭ !!", e);
		} catch (IOException e) {
			logger.error("ikki.properties  ʱȭ !!", e);
		}

		String log4jFilePath = getInitParameter("log4jFilePath");
		String refreshTime = getInitParameter("refreshTime");

		if (logger.isDebugEnabled()) {
			logger.debug("Log4J Configuration File Path : " + log4jFilePath);
			logger.debug("Timer Refresh Time : " + refreshTime);
		}

		long time = 1000;
		if (refreshTime != null) {
			time = Long.parseLong(refreshTime);
		}

		timer = new Log4JConfRefreshTimer();
		timer.startLogFileMonitor(time, log4jFilePath);

		if (logger.isInfoEnabled()) {
			logger.info("Application Initialize Success!!");
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.servlet.Servlet#destroy()
	 */
	public void destroy() {
		super.destroy();
		timer.cancel();
	}
}
